<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSegmentBooking ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSegmentBooking
 * @subpackage Arrays
 */
class ArrayOfSegmentBooking extends AbstractStructArrayBase
{
    /**
     * The SegmentBooking
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\SegmentBooking[]
     */
    public $SegmentBooking;
    /**
     * Constructor method for ArrayOfSegmentBooking
     * @uses ArrayOfSegmentBooking::setSegmentBooking()
     * @param \App|C\StructType\SegmentBooking[] $segmentBooking
     */
    public function __construct(array $segmentBooking = array())
    {
        $this
            ->setSegmentBooking($segmentBooking);
    }
    /**
     * Get SegmentBooking value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\SegmentBooking[]|null
     */
    public function getSegmentBooking()
    {
        return isset($this->SegmentBooking) ? $this->SegmentBooking : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSegmentBooking method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSegmentBooking method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSegmentBookingForArrayConstraintsFromSetSegmentBooking(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSegmentBookingSegmentBookingItem) {
            // validation for constraint: itemType
            if (!$arrayOfSegmentBookingSegmentBookingItem instanceof \App|C\StructType\SegmentBooking) {
                $invalidValues[] = is_object($arrayOfSegmentBookingSegmentBookingItem) ? get_class($arrayOfSegmentBookingSegmentBookingItem) : sprintf('%s(%s)', gettype($arrayOfSegmentBookingSegmentBookingItem), var_export($arrayOfSegmentBookingSegmentBookingItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SegmentBooking property can only contain items of type \App|C\StructType\SegmentBooking, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SegmentBooking value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\SegmentBooking[] $segmentBooking
     * @return \App|C\ArrayType\ArrayOfSegmentBooking
     */
    public function setSegmentBooking(array $segmentBooking = array())
    {
        // validation for constraint: array
        if ('' !== ($segmentBookingArrayErrorMessage = self::validateSegmentBookingForArrayConstraintsFromSetSegmentBooking($segmentBooking))) {
            throw new \InvalidArgumentException($segmentBookingArrayErrorMessage, __LINE__);
        }
        if (is_null($segmentBooking) || (is_array($segmentBooking) && empty($segmentBooking))) {
            unset($this->SegmentBooking);
        } else {
            $this->SegmentBooking = $segmentBooking;
        }
        return $this;
    }
    /**
     * Add item to SegmentBooking value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\SegmentBooking $item
     * @return \App|C\ArrayType\ArrayOfSegmentBooking
     */
    public function addToSegmentBooking(\App|C\StructType\SegmentBooking $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\SegmentBooking) {
            throw new \InvalidArgumentException(sprintf('The SegmentBooking property can only contain items of type \App|C\StructType\SegmentBooking, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SegmentBooking[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\SegmentBooking|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\SegmentBooking|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\SegmentBooking|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\SegmentBooking|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\SegmentBooking|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SegmentBooking
     */
    public function getAttributeName()
    {
        return 'SegmentBooking';
    }
}
